freeslot(
	"MT_REDBEAT_SPRING","MT_BLUEBEAT_SPRING",
	"MT_REDBEAT_DIAG","MT_BLUEBEAT_DIAG",
	"MT_REDBEAT_HORIZ","MT_BLUEBEAT_HORIZ",
	"MT_REDBEAT_RING","MT_BLUEBEAT_RING",
	
	"SPR_RBSP","SPR_BBSP",
	"SPR_RBSD","SPR_BBSD",
	"SPR_RBSH","SPR_BBSH",
	"SPR_RBRN","SPR_BBRN",
	
	"S_RBSPRING","S_BBSPRING",
	"S_RBSPRING2","S_BBSPRING2",
	"S_RBSPRING3","S_BBSPRING3",
	"S_RBSPRING4","S_BBSPRING4",
	"S_RBSPRING5","S_BBSPRING5",
	"S_RBRING","S_BBRING"
)
for i = 1,8
	freeslot(
		"S_RBDIAG"+i,"S_BBDIAG"+i,
		"S_RBHORIZ"+i,"S_BBHORIZ"+i
	)
end

states[S_RBRING] = {SPR_RBRN,FF_ANIMATE|FF_GLOBALANIM,-1,nil,23,1,S_RBRING}
states[S_BBRING] = {SPR_BBRN,FF_ANIMATE|FF_GLOBALANIM,-1,nil,23,1,S_BBRING}

//Red-beat spring
states[S_RBSPRING] = {SPR_RBSP,FF_SEMIBRIGHT,-1,nil,0,0,S_NULL}
states[S_RBSPRING2] = {SPR_RBSP,E|FF_SEMIBRIGHT,4,A_Pain,0,0,S_RBSPRING3}
states[S_RBSPRING3] = {SPR_RBSP,D|FF_SEMIBRIGHT,1,nil,0,0,S_RBSPRING4}
states[S_RBSPRING4] = {SPR_RBSP,C|FF_SEMIBRIGHT,1,nil,0,0,S_RBSPRING5}
states[S_RBSPRING5] = {SPR_RBSP,B|FF_SEMIBRIGHT,1,nil,0,0,S_RBSPRING}

states[S_RBDIAG1] = {SPR_RBSD,FF_SEMIBRIGHT,-1,nil,0,0,S_NULL}
states[S_RBDIAG2] = {SPR_RBSD,B|FF_SEMIBRIGHT,1,A_Pain,0,0,S_RBDIAG3}
states[S_RBDIAG3] = {SPR_RBSD,C|FF_SEMIBRIGHT,1,nil,0,0,S_RBDIAG4}
states[S_RBDIAG4] = {SPR_RBSD,D|FF_SEMIBRIGHT,1,nil,0,0,S_RBDIAG5}
states[S_RBDIAG5] = {SPR_RBSD,E|FF_SEMIBRIGHT,1,nil,0,0,S_RBDIAG6}
states[S_RBDIAG6] = {SPR_RBSD,D|FF_SEMIBRIGHT,1,nil,0,0,S_RBDIAG7}
states[S_RBDIAG7] = {SPR_RBSD,C|FF_SEMIBRIGHT,1,nil,0,0,S_RBDIAG8}
states[S_RBDIAG8] = {SPR_RBSD,B|FF_SEMIBRIGHT,1,nil,0,0,S_RBDIAG1}

states[S_RBHORIZ1] = {SPR_RBSH,FF_SEMIBRIGHT,-1,nil,0,0,S_NULL}
states[S_RBHORIZ2] = {SPR_RBSH,B|FF_SEMIBRIGHT,1,A_Pain,0,0,S_RBHORIZ3}
states[S_RBHORIZ3] = {SPR_RBSH,C|FF_SEMIBRIGHT,1,nil,0,0,S_RBHORIZ4}
states[S_RBHORIZ4] = {SPR_RBSH,D|FF_SEMIBRIGHT,1,nil,0,0,S_RBHORIZ5}
states[S_RBHORIZ5] = {SPR_RBSH,E|FF_SEMIBRIGHT,1,nil,0,0,S_RBHORIZ6}
states[S_RBHORIZ6] = {SPR_RBSH,D|FF_SEMIBRIGHT,1,nil,0,0,S_RBHORIZ7}
states[S_RBHORIZ7] = {SPR_RBSH,C|FF_SEMIBRIGHT,1,nil,0,0,S_RBHORIZ8}
states[S_RBHORIZ8] = {SPR_RBSH,B|FF_SEMIBRIGHT,1,nil,0,0,S_RBHORIZ1}

//Blue-beat spring
states[S_BBSPRING] = {SPR_BBSP,FF_SEMIBRIGHT,-1,nil,0,0,S_NULL}
states[S_BBSPRING2] = {SPR_BBSP,E|FF_SEMIBRIGHT,4,A_Pain,0,0,S_BBSPRING3}
states[S_BBSPRING3] = {SPR_BBSP,D|FF_SEMIBRIGHT,1,nil,0,0,S_BBSPRING4}
states[S_BBSPRING4] = {SPR_BBSP,C|FF_SEMIBRIGHT,1,nil,0,0,S_BBSPRING5}
states[S_BBSPRING5] = {SPR_BBSP,B|FF_SEMIBRIGHT,1,nil,0,0,S_BBSPRING}

states[S_BBDIAG1] = {SPR_BBSD,FF_SEMIBRIGHT,-1,nil,0,0,S_NULL}
states[S_BBDIAG2] = {SPR_BBSD,B|FF_SEMIBRIGHT,1,A_Pain,0,0,S_BBDIAG3}
states[S_BBDIAG3] = {SPR_BBSD,C|FF_SEMIBRIGHT,1,nil,0,0,S_BBDIAG4}
states[S_BBDIAG4] = {SPR_BBSD,D|FF_SEMIBRIGHT,1,nil,0,0,S_BBDIAG5}
states[S_BBDIAG5] = {SPR_BBSD,E|FF_SEMIBRIGHT,1,nil,0,0,S_BBDIAG6}
states[S_BBDIAG6] = {SPR_BBSD,D|FF_SEMIBRIGHT,1,nil,0,0,S_BBDIAG7}
states[S_BBDIAG7] = {SPR_BBSD,C|FF_SEMIBRIGHT,1,nil,0,0,S_BBDIAG8}
states[S_BBDIAG8] = {SPR_BBSD,B|FF_SEMIBRIGHT,1,nil,0,0,S_BBDIAG1}

states[S_BBHORIZ1] = {SPR_BBSH,FF_SEMIBRIGHT,-1,nil,0,0,S_NULL}
states[S_BBHORIZ2] = {SPR_BBSH,B|FF_SEMIBRIGHT,1,A_Pain,0,0,S_BBHORIZ3}
states[S_BBHORIZ3] = {SPR_BBSH,C|FF_SEMIBRIGHT,1,nil,0,0,S_BBHORIZ4}
states[S_BBHORIZ4] = {SPR_BBSH,D|FF_SEMIBRIGHT,1,nil,0,0,S_BBHORIZ5}
states[S_BBHORIZ5] = {SPR_BBSH,E|FF_SEMIBRIGHT,1,nil,0,0,S_BBHORIZ6}
states[S_BBHORIZ6] = {SPR_BBSH,D|FF_SEMIBRIGHT,1,nil,0,0,S_BBHORIZ7}
states[S_BBHORIZ7] = {SPR_BBSH,C|FF_SEMIBRIGHT,1,nil,0,0,S_BBHORIZ8}
states[S_BBHORIZ8] = {SPR_BBSH,B|FF_SEMIBRIGHT,1,nil,0,0,S_BBHORIZ1}

mobjinfo[MT_REDBEAT_SPRING] = {
	--$Name Red-beat Spring (Yellow)
    --$Sprite RBSPE0
    --$Category RhythmSync
	doomednum = 2011,
	spawnstate = S_RBSPRING,
	painsound = sfx_spring,
	radius = 20*FRACUNIT,
	height = 16*FRACUNIT,
	mass = 20*FRACUNIT,
	flags = MF_SPRING|MF_NOGRAVITY,
	raisestate = S_RBSPRING2
}

mobjinfo[MT_REDBEAT_DIAG] = {
	--$Name Red-beat Diagonal Spring (Yellow)
    --$Sprite RBSDE0
    --$Category RhythmSync
	doomednum = 2012,
	spawnstate = S_RBDIAG1,
	painsound = sfx_spring,
	radius = 20*FRACUNIT,
	height = 16*FRACUNIT,
	mass = 20*FRACUNIT,
	damage = 20*FRACUNIT,
	flags = MF_SPRING|MF_NOGRAVITY,
	raisestate = S_RBDIAG2
}

mobjinfo[MT_REDBEAT_HORIZ] = {
	--$Name Red-beat Horizontal Spring (Yellow)
    --$Sprite RBSHE0
    --$Category RhythmSync
	doomednum = 2013,
	spawnstate = S_RBHORIZ1,
	painsound = sfx_spring,
	radius = 20*FRACUNIT,
	height = 16*FRACUNIT,
	damage = 36*FRACUNIT,
	flags = MF_SPRING|MF_NOGRAVITY,
	raisestate = S_RBHORIZ2
}

mobjinfo[MT_BLUEBEAT_SPRING] = {
	--$Name Blue-beat Spring (Yellow)
    --$Sprite BBSPE0
    --$Category RhythmSync
	doomednum = 2014,
	spawnstate = S_BBSPRING,
	painsound = sfx_spring,
	radius = 20*FRACUNIT,
	height = 16*FRACUNIT,
	mass = 20*FRACUNIT,
	flags = MF_SPRING|MF_NOGRAVITY|MF_NOCLIPTHING,
	raisestate = S_BBSPRING2
}

mobjinfo[MT_BLUEBEAT_DIAG] = {
	--$Name Blue-beat Diagonal Spring (Yellow)
    --$Sprite BBSDE0
    --$Category RhythmSync
	doomednum = 2015,
	spawnstate = S_BBDIAG1,
	painsound = sfx_spring,
	radius = 20*FRACUNIT,
	height = 16*FRACUNIT,
	mass = 20*FRACUNIT,
	damage = 20*FRACUNIT,
	flags = MF_SPRING|MF_NOGRAVITY|MF_NOCLIPTHING,
	raisestate = S_BBDIAG2
}

mobjinfo[MT_BLUEBEAT_HORIZ] = {
	--$Name Blue-beat Horizontal Spring (Yellow)
    --$Sprite BBSHE0
    --$Category RhythmSync
	doomednum = 2016,
	spawnstate = S_BBHORIZ1,
	painsound = sfx_spring,
	radius = 20*FRACUNIT,
	height = 16*FRACUNIT,
	damage = 36*FRACUNIT,
	flags = MF_SPRING|MF_NOGRAVITY|MF_NOCLIPTHING,
	raisestate = S_BBHORIZ2
}

mobjinfo[MT_REDBEAT_RING] = {
	--$Name Red-beat Ring
    --$Sprite RBRNA0
    --$Category RhythmSync
	doomednum = 2017,
	spawnstate = S_RBRING,
	spawnhealth = 1000,
	reactiontime = MT_FLINGRING,
	deathsound = sfx_itemup,
	speed = 38*FRACUNIT,
	radius = 16*FRACUNIT,
	height = 24*FRACUNIT,
	mass = 100,
	flags = MF_SLIDEME|MF_SPECIAL|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}

mobjinfo[MT_BLUEBEAT_RING] = {
	--$Name Blue-beat Ring
    --$Sprite BBRNA0
    --$Category RhythmSync
	doomednum = 2018,
	spawnstate = S_BBRING,
	spawnhealth = 1000,
	reactiontime = MT_FLINGRING,
	deathsound = sfx_itemup,
	speed = 38*FRACUNIT,
	radius = 16*FRACUNIT,
	height = 24*FRACUNIT,
	mass = 100,
	flags = MF_SLIDEME|MF_SPECIAL|MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_NOCLIPTHING
}

local RingSpecial = function(mobj,mo)
	if mobj and mobj.valid
	and mo and mo.valid
	and mo.player and mo.player.valid
		if not P_CanPickupItem(mo.player,false) and not (mobj.flags & MF2_NIGHTSPULL)
			mobj.momx = 0
			mobj.momy = 0
			mobj.momz = 0
			P_GivePlayerRings(mo.player,1)
			
			if (maptol & TOL_NIGHTS)
				P_DoNightsScore(mo.player)
			end
		end
	end
end
addHook("TouchSpecial",RingSpecial,MT_REDBEAT_RING)
addHook("TouchSpecial",RingSpecial,MT_BLUEBEAT_RING)

local RedBlueSpawn = function(mo)
	if not MusicSync then return end
	if not (mapheaderinfo[gamemap].rhythmmap) then return end
	if not (mo and mo.valid) then return end
	
	if (mo.info.flags & MF_NOCLIPTHING)
		mo.rhythmoff = true
		mo.frame = ($&~FF_TRANSMASK)|FF_TRANS50
	end
	table.insert(MusicSync.switchobjects,mo)
end
addHook("MobjSpawn",RedBlueSpawn,MT_REDBEAT_SPRING)
addHook("MobjSpawn",RedBlueSpawn,MT_REDBEAT_DIAG)
addHook("MobjSpawn",RedBlueSpawn,MT_REDBEAT_HORIZ)
addHook("MobjSpawn",RedBlueSpawn,MT_REDBEAT_RING)

addHook("MobjSpawn",RedBlueSpawn,MT_BLUEBEAT_SPRING)
addHook("MobjSpawn",RedBlueSpawn,MT_BLUEBEAT_DIAG)
addHook("MobjSpawn",RedBlueSpawn,MT_BLUEBEAT_HORIZ)
addHook("MobjSpawn",RedBlueSpawn,MT_BLUEBEAT_RING)

local DoRender = function()
	if not MusicSync then return end
	if not (mapheaderinfo[gamemap].rhythmmap) then return end
	
	if MusicSync.switchobjects
		for k,v in ipairs(MusicSync.switchobjects)
			local mo = MusicSync.switchobjects[k]
			if mo and mo.valid
				if mo.rhythmoff
				and not (mo.frame & FF_TRANS50)
					mo.frame = ($&~FF_TRANSMASK)|FF_TRANS50
				elseif (mo.frame & FF_TRANSMASK)
					mo.frame = $&~FF_TRANSMASK
				end
			end
		end
	end
end
addHook("PreThinkFrame",DoRender)
addHook("PostThinkFrame",DoRender)